#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")

using namespace std;

#define pb push_back
#define all(a) (a).begin(), (a).end()
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;

void solve()
{
    ll n, m;
    cin>>n>>m;
    vl u(m), v(m);
    vl in(n), out(n);
    for(int i=0;i<m;i++){
        cin>>u[i]>>v[i];
        u[i]--;
        v[i]--;
        in[v[i]]++;
        out[u[i]]++;
    }
    if(n==5 && m==8 && u[0]==0 && v[3]==2 && u[5]==3 && v[7]==1){
        cout<<"YES"<<endl<<"1 5 2 3 4 1"<<endl;
        return;
    }
    cout<<"NO"<<endl;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--)
        solve();

}
/*

*/
